#!/usr/bin/env python
#-*- coding: UTF-8 -*-
 
import wx
from   .mumamisc import *

class CustomStatusBar(wx.StatusBar):
    ID_LED = wx.NewId()
    MAX_GAUGE = 100
    
    def __init__(self, parent):
        wx.StatusBar.__init__(self, parent, -1)
        self.parent = parent
        self.Bind(wx.EVT_SIZE, self.rePosition)
        self.dc = wx.ScreenDC()
        self.SetFieldsCount(5)
        self.SetStatusWidths([220, 22, 120, 100, -1])
        self.SetStatusStyles([3, 3, 3, 3, 3])  # wx.SB_SUNKEN geht nicht !!??
        self.led = wx.TextCtrl(self, -1, ' ', size = (16, 16), style = wx.TE_READONLY)
        #self.diskstat = wx.Gauge(self, -1, self.MAX_GAUGE, size = wx.Size(112, -1), style = wx.Gauge().GA_PROGRESS | wx.GA_SMOOTH)
        self.diskstat = wx.Gauge(self, -1, self.MAX_GAUGE, size = wx.Size(112, -1), style = wx.GA_SMOOTH)
        self.setLed(RED)
        self.rePosition()
    #-------------------------------------------------------------------------------------------------------

    def setLed(self, color, setoldval = False):
        self.led.SetBackgroundColour(color)
        self.led.Clear()
        if setoldval: self.oldcolor = color
    #-------------------------------------------------------------------------------------------------------

    def restoreLed(self):
        self.led.SetBackgroundColour(self.oldcolor)
        self.led.Clear()
    #-------------------------------------------------------------------------------------------------------

    def setGauge(self, scale):
        """ Progress Bar veraendern """
        self.diskstat.SetValue(scale)
        self.diskstat.SetToolTip(wx.ToolTip('%s%% full' % (int(scale))))
        pass
    #-------------------------------------------------------------------------------------------
      
    def rePosition(self, event = None):
        rect1 = self.GetFieldRect(1)
        w,h = self.dc.GetTextExtent(self.GetStatusText(3))
        self.SetStatusWidths([220, rect1.height + 3, 120, w + 10, -1])
        self.led.SetPosition(wx.Point(rect1.x, rect1.y))            
        rect2 = self.GetFieldRect(2)             # Progress Bar
        self.diskstat.SetPosition(wx.Point(rect2.x + 2, rect2.y + 1))
        self.diskstat.SetSize(wx.Size(rect2.width - 4, rect2.height - 1))
# - CustomStatusBar(wx.StatusBar):-------------------------------------------------------------------------
