#!/usr/bin/env python
#-*- coding: UTF-8 -*-

import wx
from . import mumapopup
from . import mumavlist
from   .mumamisc import *
  
class QuickParamDialog(wx.Dialog):
    ID_CB_FUZZY = wx.NewId()
    ID_CB_TITLE = wx.NewId()
    ID_CB_ALBUM = wx.NewId()
    ID_CB_INTERP = wx.NewId()
    ID_CB_ELSEW = wx.NewId()
    ID_CB_LEFT = wx.NewId()
   
    def __init__(self, parent, config, database, onCheckMusicDir, listwin, updateMatches, onPlayTitle, misslist):        
        """  as """
        windowpos = (wx.Point(int(config['Window']['qqposx']),
                              int(config['Window']['qqposy'])))
        windowsize = (wx.Size(int(config['Window']['qqsizex']),
                              int(config['Window']['qqsizey'])))                        
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - Quick query', pos = windowpos,
                           size = windowsize, style = wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER)
        self.parent = parent
        self.config = config
        self.misslist = misslist
        btnadj = int(config['Misc']['norm'] == 'False')
        self.mumadb = database
        self.qqlimit = config['Database']['qqlimit']
        self.onCheckMusicDir = onCheckMusicDir
        self.onPlayTitle = onPlayTitle
        self.listwin = listwin
        self.updateMatches = updateMatches
        self.quickquery = config['Queries']['QuickQuery']
        self.lastquery = ''
        self.fuzzyhist = self.quickquery['fuzzyhist']
        self.titlehist = self.quickquery['titlehist']
        self.interhist = self.quickquery['interhist']
        self.selindex = None
        self.cbalbum = False
        collist = config['Misc']['hlcolor']
        self.hlcolor = (int(collist[0]), int(collist[1]), int(collist[2]))
        collist = config['Misc']['99color']
        self.color99 = (int(collist[0]), int(collist[1]), int(collist[2]))
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        self.sb = wx.StaticBox(self, -1, ' Id_Title, Title and Interpreter ordered by Id_Title [0] ')
        lcsizer = wx.StaticBoxSizer(self.sb, wx.HORIZONTAL)
        self.sli = mumavlist.VirtualListCtrl(self, -1, self.config, singlesel = True)
        self.sli.InsertColumn(0, 'Id_Title', width = int(self.config['Window']['qqcolwidth'][0]))
        self.sli.InsertColumn(1, 'Title', width = int(self.config['Window']['qqcolwidth'][1]))
        self.sli.InsertColumn(2, 'Interpreter', width = int(self.config['Window']['qqcolwidth'][2]))
        self.sli.SetColumnCount(3)
        self.Bind(wx.EVT_LIST_ITEM_SELECTED, self.onSelectItem, self.sli)
        self.Bind(wx.EVT_LIST_ITEM_ACTIVATED, self.onPlayItemClicked, self.sli)
        #self.Bind(wx.EVT_LIST_ITEM_RIGHT_CLICK, self.onItemProperties, self.sli)
        self.Bind(wx.EVT_LIST_ITEM_RIGHT_CLICK, self.onShowContext, self.sli)
        self.Bind(wx.EVT_LIST_COL_CLICK, self.onColumnSort, self.sli)
        lcsizer.Add(self.sli, 1, wx.GROW | wx.ALL, GAP)
        sizer.Add(lcsizer, 1, wx.GROW | wx.ALL, BORDER)
         
        bottomsz = wx.BoxSizer(wx.VERTICAL)               
        box1 = wx.StaticBox(self, -1, " query Title OR Interpreter ")
        bsz1 = wx.StaticBoxSizer(box1, wx.HORIZONTAL)
        fgsz1 = wx.FlexGridSizer(1, 2, 0, 0)
        fgsz1.AddGrowableCol(1)
         
        self.cbf = wx.CheckBox(self, self.ID_CB_FUZZY, 'Fuzzy:     ')
        self.Bind(wx.EVT_CHECKBOX, self.onCbFuzzy, id = self.ID_CB_FUZZY)
        fgsz1.Add(self.cbf, 0, wx.ALL, GAP)
        self.cbxf = wx.ComboBox(self, -1, self.fuzzyhist[0],
                                choices = self.fuzzyhist,
                                style = wx.TE_PROCESS_ENTER)               
        fgsz1.Add(self.cbxf, 1, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_CLOSE, self.onCancel)
        self.Bind(wx.EVT_TEXT_ENTER, self.onHitReturn, self.cbxf)
        self.Bind(wx.EVT_TEXT, self.onFuzzyText, self.cbxf)
        bsz1.Add(fgsz1, 1, wx.GROW)
        bottomsz.Add(bsz1,  0, wx.GROW | wx.LEFT | wx.RIGHT , GAP)
        
        box2 = wx.StaticBox(self, -1, " query Title, Interpreter or Title AND Interpreter ")
        bsz2 = wx.StaticBoxSizer(box2, wx.VERTICAL)
        fgsz2 = wx.FlexGridSizer(2, 2, 0, 0)
        fgsz2.AddGrowableCol(1)

        self.cbt = wx.CheckBox(self, self.ID_CB_TITLE, 'Title:')
        self.Bind(wx.EVT_CHECKBOX, self.onCbTitleOrInterp, id = self.ID_CB_TITLE)
        fgsz2.Add(self.cbt, 0, wx.ALL, GAP)
        self.cbxt = wx.ComboBox(self, -1, self.titlehist[0],
                                choices = self.titlehist,
                                style = wx.TE_PROCESS_ENTER)               
        fgsz2.Add(self.cbxt, 1, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT_ENTER, self.onHitReturn, self.cbxt)
        self.Bind(wx.EVT_TEXT, self.onText, self.cbxt)    
     #   self.cbxt.SetFocusFromKbd()
        self.cbi = wx.CheckBox(self, self.ID_CB_INTERP, 'Interpreter:')
        self.Bind(wx.EVT_CHECKBOX, self.onCbTitleOrInterp, id = self.ID_CB_INTERP)
        fgsz2.Add(self.cbi, 0, wx.ALL, GAP)
        self.cbxi = wx.ComboBox(self, -1, self.interhist[0],
                                choices = self.interhist,
                                style = wx.TE_PROCESS_ENTER)        
        
        fgsz2.Add(self.cbxi, 1, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT_ENTER, self.onHitReturn, self.cbxi)
        self.Bind(wx.EVT_TEXT, self.onText, self.cbxi)
        bsz2.Add(fgsz2, 1, wx.GROW)        
        bottomsz.Add(bsz2, 0, wx.GROW | LRT, GAP)

        box3 = wx.RadioBox(self, -1, " parameter position ", wx.DefaultPosition, wx.DefaultSize,
                          ['no wild (i.e. ABC)  ', 'left (i.e. Abc%)  ', 'elsewhere (i.e. %Abc%)'], 3, wx.RA_SPECIFY_COLS)
        box3.SetSelection(int(self.quickquery['radiobox']))
        self.Bind(wx.EVT_RADIOBOX, self.evtRadioBox, box3)
        bottomsz.Add(box3, 0, wx.GROW | wx.ALL, GAP)
        
        box4 = wx.StaticBox(self, -1, " use this option with extreme care and be patient! ")
        bsz4 = wx.StaticBoxSizer(box4, wx.HORIZONTAL)
        self.cba = wx.CheckBox(self, self.ID_CB_ALBUM, 'Album:  (if checked, scan music device for album tags) ')
        self.Bind(wx.EVT_CHECKBOX, self.onCbAlbum, id = self.ID_CB_ALBUM)
        bsz4.Add(self.cba, 0, wx.ALL, GAP)
        bottomsz.Add(bsz4, 0, wx.GROW | LRT, GAP)        
        
        butrow = wx.BoxSizer(wx.HORIZONTAL)
        if not btnadj: butrow.AddStretchSpacer()
        butok = wx.Button(self, wx.ID_OK)
        self.Bind(wx.EVT_BUTTON, self.onOk, id = wx.ID_OK)
        butrow.Add(butok, btnadj, wx.GROW | wx.TOP | wx.RIGHT, GAP)    
        butcancel = wx.Button(self, wx.ID_CANCEL)
        self.Bind(wx.EVT_BUTTON, self.onCancel, id = wx.ID_CANCEL)
        butrow.Add(butcancel, btnadj, wx.GROW | wx.TOP | wx.LEFT, GAP)
        bottomsz.Add(butrow, btnadj, wx.GROW | wx.ALL, GAP)        
        sizer.Add(bottomsz, 0, wx.GROW | wx.LEFT | wx.RIGHT | wx.BOTTOM, GAP)        
        self.SetSizer(sizer)
        self.SetMinSize(wx.Size(450, 480))
        self.initContextMenu()
        self.enableDisable()
    #-------------------------------------------------------------------------------------------

    def initContextMenu(self):
        self.playpopupID0 = wx.NewId()  
        self.playpopupID1 = wx.NewId()          
        self.playpopupID2 = wx.NewId()
        self.playpopupID3 = wx.NewId()
        self.playpopupID4 = wx.NewId()
        self.Bind(wx.EVT_MENU, self.onPlayItemClicked, id = self.playpopupID0)
        self.Bind(wx.EVT_MENU, self.onQueueTitle, id = self.playpopupID1)
        self.Bind(wx.EVT_MENU, self.onAddToPlaylist, id = self.playpopupID2)
        self.Bind(wx.EVT_MENU, self.onCopyTitle, id = self.playpopupID3)
        self.Bind(wx.EVT_MENU, self.onItemProperties, id = self.playpopupID4)
    #-------------------------------------------------------------------------------------------

    def onShowContext(self, event):
        """ context menu handler """
        menu = wx.Menu()       
        item = wx.MenuItem(menu, self.playpopupID0, 'Play title')
        item.SetBitmap(loadIcon('play.png')) 
        menu.AppendItem(item)       
        item = wx.MenuItem(menu, self.playpopupID1, 'Queue title')
        item.SetBitmap(loadIcon('play.png')) 
        menu.AppendItem(item)
        item = wx.MenuItem(menu, self.playpopupID2, 'Add to playlist')
        item.SetBitmap(loadIcon('addlist.png')) 
        menu.AppendItem(item)
        menu.AppendSeparator()
        item = wx.MenuItem(menu, self.playpopupID3, 'Copy file')
        item.SetBitmap(loadIcon('copy.png')) 
        menu.AppendItem(item)
        menu.AppendSeparator()         
        item = wx.MenuItem(menu, self.playpopupID4, 'File properties')
        item.SetBitmap(loadIcon('properties.png')) 
        menu.AppendItem(item) 
        self.PopupMenu(menu)
        menu.Destroy()
    #-------------------------------------------------------------------------------------------      

    def onSelectItem(self, event):
        self.selindex = event.GetIndex()
    #-------------------------------------------------------------------------------------------

    def onCopyTitle(self, event):
        self.parent.onCopy(listwin = self.sli)
    #-------------------------------------------------------------------------------------------

    def onAddToPlaylist(self, event):
        self.parent.onAddToPlaylist(listwin = self.sli)
    #-------------------------------------------------------------------------------------------
    
    def onItemProperties(self, event):
        index = self.sli.GetNextItem(-1, wx.LIST_NEXT_ALL, wx.LIST_STATE_SELECTED)   
        item = self.sli.GetItem(index, 0)
        id_title = item.GetText()
        if not (id_title.startswith('99') or id_title.endswith('00')):
            win = mumapopup.PropertyPopup(self, self.config, self.mumadb, id_title, self.parent.playlists)
            pos = self.ClientToScreen((0,0))  # pos is the left top edge of the win
            sz = self.GetSize()               # sz is the size of the win
            win.Position((pos[0] + sz[0] / 2, pos[1] - sz[1] / 2), (0, sz[1]))       
            win.Popup()            
    #-------------------------------------------------------------------------------------------

    def onPlayItemClicked(self, event):     
        index = self.sli.GetNextItem(-1, wx.LIST_NEXT_ALL, wx.LIST_STATE_SELECTED)        
        item = self.sli.GetItem(index, 0)
        id_title = item.GetText()
        if not (id_title.startswith('99') or id_title.endswith('00')):
            self.onPlayTitle(id = id_title, top25 = False)
    #-------------------------------------------------------------------------------------------
            
    def onQueueTitle(self, event):     
        index = self.sli.GetNextItem(-1, wx.LIST_NEXT_ALL, wx.LIST_STATE_SELECTED)        
        item = self.sli.GetItem(index, 0)
        id_title = item.GetText()
        if not (id_title.startswith('99') or id_title.endswith('00')):
            self.parent.onPlayTitle(id = id_title, queue = True)
    #-------------------------------------------------------------------------------------------

    def evtRadioBox(self, event):
        self.quickquery['radiobox'] = event.GetInt()
        self.enableDisable()
    #-------------------------------------------------------------------------------------------

    def onCbAlbum(self, event = None, reset = False):
        if event == None:
            if not self.cba.GetValue(): return
            self.cba.SetValue(not reset)
            
        self.cbalbum = self.cba.GetValue()
        if self.cbalbum:
            if not self.parent.onCheckMusicDir():
                self.parent.writeToLogwin('Play title - music device not present')
                self.parent.showDeviceHint('music device not present')
                self.cba.SetValue(False)
                return
            
            self.sli.InsertColumn(3, 'Album', width = int(self.config['Window']['qqcolwidth'][3]))
            self.sli.SetColumnCount(4)
        elif self.sli.GetColumnCount() > 3:
            self.sli.SetColumnCount(3)
            self.sli.DeleteColumn(3)        
        self.updateListctrl(self.lastquery, True)
    #-------------------------------------------------------------------------------------------
        
    def onCbFuzzy(self, event):
        self.onCbAlbum(reset = True)
        cbfuzzy = self.cbf.GetValue()
        self.quickquery['cbfuzzy'] = str(cbfuzzy)
        if cbfuzzy:
            self.quickquery['cbtitle'] = 'False'
            self.quickquery['cbinter'] = 'False'
        else:
            self.quickquery['cbtitle'] = 'True'
            self.quickquery['cbinter'] = 'True'
        self.enableDisable()
    #-------------------------------------------------------------------------------------------
                        
    def onCbTitleOrInterp(self, event):
        self.onCbAlbum(reset = True)   
        cbtitle = self.cbt.GetValue()
        self.quickquery['cbtitle'] = str(cbtitle)
        cbinter = self.cbi.GetValue()
        self.quickquery['cbinter'] = str(cbinter)
        if cbtitle or cbinter:
            self.quickquery['cbfuzzy'] = 'False'
        else:
            self.quickquery['cbfuzzy'] = 'True'
        self.enableDisable()
    #-------------------------------------------------------------------------------------------   
    
    def enableDisable(self):
        cbf = self.quickquery['cbfuzzy'] == 'True'
        cbt = self.quickquery['cbtitle'] == 'True'
        cbi = self.quickquery['cbinter'] == 'True'
        self.cbf.SetValue(cbf)
        self.cbxf.Enable(cbf)
        self.cbt.SetValue(cbt)
        self.cbxt.Enable(cbt)
        self.cbi.SetValue(cbi)
        
        self.cbxt.Enable(cbt)
        self.cbxi.Enable(cbi)
        self.sli.ClearImages()
        if cbf:
            self.cbxf.SetFocus()           
            self.onFuzzyText()
        elif cbt:
            self.cbxt.SetFocus()
            self.onText()
        else:
            self.cbxi.SetFocus()
            self.onText()
    #-------------------------------------------------------------------------------------------
        
    def onColumnSort(self, event = None, column = 1):
        if event != None:
            column = event.Column
            orderby = ['Id_Title', 'Title, Interpreter', 'Interpreter, Title'][column]
            direction = (self.sli.GetSortDirection(column) + 1) % 2
        else:
            if column == 1:
                orderby = 'Title, Interpreter'
            else:
                orderby = 'Interpreter, Title'
            direction = self.sli.GetSortDirection(column)
        savequery = self.lastquery
        
        if direction < 1:
            orderby = orderby.replace(',', ' ASC,')
            query = self.lastquery.replace('LIMIT %s' % (self.qqlimit), 'ORDER BY %s LIMIT %s' % (orderby, self.qqlimit))
        else:
            orderby = orderby.replace(',', ' DESC,')
            query = self.lastquery.replace('LIMIT %s' % (self.qqlimit), 'ORDER BY %s LIMIT %s' % (orderby, self.qqlimit))
        self.updateListctrl(query, True)
        self.sli.UpdateImages(column, direction)
        self.lastquery = savequery
    #-------------------------------------------------------------------------------------------

    def onFuzzyText(self, event = None):
        self.onCbAlbum(reset = True)
        txtitem = self.cbxf.GetValue()
        index = int(self.quickquery['radiobox'])
        if index == 0:
            maskt = txtitem
        elif index == 1:    
            maskt = txtitem + '%'
        else:
            maskt = '%' + txtitem + '%'
        query = 'SELECT * FROM muma_title WHERE Title LIKE "%s" OR Interpreter LIKE "%s" LIMIT %s' % (maskt, maskt, self.qqlimit)       
        self.updateListctrl(query, True)
    #-------------------------------------------------------------------------------------------

    def onText(self, event = None):
        self.onCbAlbum(reset = True)
        txtitem = self.cbxt.GetValue()
        index = int(self.quickquery['radiobox'])
        if index == 0:
            maskt = txtitem
        elif index == 1:            
            maskt = txtitem + '%'
        else:
            maskt = '%' + txtitem + '%'
            
        txtitem = self.cbxi.GetValue()
        if index == 0:
            maski = txtitem
        elif index == 1:
            maski = txtitem + '%'
        else:
            maski = '%' + txtitem + '%'
        if self.cbt.GetValue() and not self.cbi.GetValue():
            query = 'SELECT * FROM muma_title WHERE Title LIKE "%s" LIMIT %s' % (maskt, self.qqlimit)
            self.lastquery = query
            self.onColumnSort(column = 1) 
        elif not self.cbt.GetValue() and self.cbi.GetValue():
            query = 'SELECT * FROM muma_title WHERE Interpreter LIKE "%s" LIMIT %s' % (maski, self.qqlimit)
            self.lastquery = query
            self.onColumnSort(column = 2)
        else:
            query = 'SELECT * FROM muma_title WHERE Title LIKE "%s" AND Interpreter LIKE "%s" LIMIT %s' % (maskt, maski, self.qqlimit)
            self.updateListctrl(query, True)
    #-------------------------------------------------------------------------------------------

    def updateListctrl(self, query, updatematches):     # virtual ListCtrl version
        try:
            cquery = "SELECT count(*) " + query[query.index('FROM') : query.index('LIMIT')]
            counttup, dummy = self.mumadb.getMatches(cquery)
            allcount = counttup[0][0]
            self.records, self.matchcount = self.mumadb.getMatches(query)
            if updatematches:
                if allcount > int(self.qqlimit):
                    sapp = '[limited to %i of %i] ' % (self.matchcount, allcount)
                else:
                    sapp = '[%i] ' % (self.matchcount)
                if self.cbalbum:
                    self.sb.SetLabel(' Id_Title, Title, Interpreter and Album ordered by Id_Title %s' % (sapp))
                else:
                    self.sb.SetLabel(' Id_Title, Title and Interpreter ordered by Id_Title %s' % (sapp))
                self.Refresh()

            records = []
            for record in self.records:
                id_title = record[0]
                tagalbum = '???'
                if self.cbalbum:
                    meta, dummy1, dummy2, dummy3 = getTagInfo(self.config, str(id_title))
                    if 'album' in meta:
                        tagalbum = meta['album'][0]
                                        
                newrecord = (id_title, record[1], record[2], tagalbum)
                records.append(newrecord)                
                
            self.sli.setDataSource(records, self.matchcount, self.misslist)    
            self.lastquery = query
        except:
            self.records = None
            self.matchcount = 0
    #-------------------------------------------------------------------------------------------
        
    def onHitReturn(self, event):
        self.saveCombos()
        self.parent.prepareDisplay()
        self.listwin.setDataSource(self.records, self.matchcount, self.misslist)
        self.EndModal(wx.ID_OK)
    #-------------------------------------------------------------------------------------------

    def onCancel(self, event):
        self.EndModal(wx.ID_CANCEL)
    #-------------------------------------------------------------------------------------------
        
    def onOk(self, event):
        self.parent.prepareDisplay()
        self.listwin.setDataSource(self.records, self.matchcount, self.misslist)
        self.saveCombos()  
        self.EndModal(wx.ID_OK)
    #-------------------------------------------------------------------------------------------

    def saveCombos(self):
        txtitem = self.cbxf.GetValue()
        if not txtitem:
            txtitem = self.fuzzyhist[0]
            self.cbxf.SetValue(txtitem)
            
        if txtitem != self.fuzzyhist[0]:
            if txtitem in self.fuzzyhist:
                self.fuzzyhist.remove(txtitem)
            self.fuzzyhist.insert(0, txtitem)
            if len(self.fuzzyhist) == 9:
                del self.fuzzyhist[8]
            self.cbxf.Clear()
            for item in self.fuzzyhist:
                self.cbxf.Append(item)
            self.cbxf.SetValue(txtitem)

        txtitem = self.cbxt.GetValue()
        if not txtitem:
            txtitem = self.titlehist[0]
            self.cbxt.SetValue(txtitem)
            
        if txtitem != self.titlehist[0]:
            if txtitem in self.titlehist:
                self.titlehist.remove(txtitem)
            self.titlehist.insert(0, txtitem)
            if len(self.titlehist) == 9:
                del self.titlehist[8]
            self.cbxt.Clear()
            for item in self.titlehist:
                self.cbxt.Append(item)
            self.cbxt.SetValue(txtitem)
            
        txtitem = self.cbxi.GetValue()
        if not txtitem:
            txtitem = self.interhist[0]
            self.cbxi.SetValue(txtitem)
            
        if txtitem != self.interhist[0]:
            if txtitem in self.interhist:
                self.interhist.remove(txtitem)
            self.interhist.insert(0, txtitem)
            if len(self.interhist) == 9:
                del self.interhist[8]
            self.cbxi.Clear()
            for item in self.interhist:
                self.cbxi.Append(item)
            self.cbxi.SetValue(txtitem)
        
        self.windowPosition()
    #-------------------------------------------------------------------------------------------
        
    def windowPosition(self):
        windowrect = self.GetRect()
        self.config['Window']['qqposx'] = windowrect[0]
        self.config['Window']['qqposy'] = windowrect[1]
        self.config['Window']['qqsizex'] = windowrect[2]
        self.config['Window']['qqsizey'] = windowrect[3]
        for i in range(3):
            self.config['Window']['qqcolwidth'][i] = self.sli.GetColumnWidth(i)
    #-------------------------------------------------------------------------------------------

    def getValues(self):
        return self.lastquery, self.fuzzyhist, self.titlehist, self.interhist, self.selindex, self.matchcount        
# - class QuickParamDialog(wx.Dialog):----------------------------------------------------------


class ParamDialog(wx.Dialog):
    COMP = ['LIKE', '<', '<=', '>', '>=', '=', '!=', '<>']
    
    def __init__(self, parent, freewhere, paramhist, paramhist2 = None):        
        """  as """
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - parameter entry')
        btnadj = int(parent.config['Misc']['norm'] == 'False')
        self.paramhist = paramhist
        self.paramhist2 = paramhist2
        
        self.parname1, parname2 = self.findParameterName(freewhere)
        txt = " Enter value for parameter '%s' " % self.parname1

        sizer = wx.BoxSizer(wx.VERTICAL)
        box1 = wx.StaticBox(self, -1, txt)
        bsz1 = wx.StaticBoxSizer(box1, wx.VERTICAL)
        self.cbx = wx.ComboBox(self, -1, paramhist[0],
                               choices = paramhist,
                               style = wx.TE_PROCESS_ENTER)        
        bsz1.Add(self.cbx, 0, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT_ENTER, self.onOk, self.cbx)
        ###self.cbx.SetMark(0, -1)   # wx4
        self.cbx.SetTextSelection(0, -1)
        self.cbx.SetFocusFromKbd()

        if paramhist2 != None:
            txt = " Enter value for parameter '%s' " % parname2
            box2 = wx.StaticBox(self, -1, txt)
            bsz2 = wx.StaticBoxSizer(box2, wx.VERTICAL)
            self.cbx2 = wx.ComboBox(self, -1, paramhist2[0],
                                   choices = paramhist2,
                                   style = wx.TE_PROCESS_ENTER)        
            bsz2.Add(self.cbx2, 0, wx.ALL | wx.GROW, GAP)
            self.Bind(wx.EVT_TEXT_ENTER, self.onOk, self.cbx2)
        
        butok = wx.Button(self, wx.ID_OK)
        self.Bind(wx.EVT_BUTTON, self.onOk, id = wx.ID_OK)
        butcancel = wx.Button(self, wx.ID_CANCEL)
        row2 = wx.BoxSizer(wx.HORIZONTAL)
        if not btnadj: row2.AddStretchSpacer()
        row2.Add(butok, btnadj, wx.GROW | wx.ALL, GAP)
        row2.Add(butcancel, btnadj, wx.GROW | wx.ALL, GAP)
    
        sizer.Add(bsz1, 0, wx.GROW | LRT, BORDER)
        if paramhist2 != None:
            sizer.Add(bsz2, 0, wx.GROW | LRT, BORDER)
        
        sizer.Add(row2, 0, wx.GROW | wx.ALL, GAP)
        self.SetSizer(sizer)
        self.SetMinSize(wx.Size(350, -1))
        self.Fit()
        self.Centre()
    #-------------------------------------------------------------------------------------------
    
    def findParameterName(self, s):
        r1 = '%param%'
        r2 = '%param2%'
        plist = s.split(' ')
        if '%param%' in s or '%param1%' in s:
            i = 0
            while i < len(plist):
                if plist[i] in self.COMP:
                    r1 = plist[i - 1]
                    i += 1
                    break
                i += 1
        if '%param2%' in s:
            while i < len(plist):
                if plist[i] in self.COMP:
                    r2 = plist[i - 1]
                    break
                i += 1        
        return r1, r2   
    #-------------------------------------------------------------------------------------------

    def onOk(self, event):
        txtitem = self.cbx.GetValue()
        if self.parname1 == 'Id_Title' and not txtitem.isdigit():
            dlg = wx.MessageDialog(self, 'only digits are allowed in Id_Title - i.e. 1234', TITLE + ' - parameter entry', wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            return
                
        if not txtitem:
            txtitem = self.paramhist[0]
            self.cbx.SetValue(txtitem)
            
        if txtitem != self.paramhist[0]:
            if txtitem in self.paramhist:
                self.paramhist.remove(txtitem)
            self.paramhist.insert(0, txtitem)
            if len(self.paramhist) == 9:
                del self.paramhist[8]
            self.cbx.Clear()
            for item in self.paramhist:
                self.cbx.Append(item)
            self.cbx.SetValue(txtitem)

        if self.paramhist2 != None:
            txtitem = self.cbx2.GetValue()
            if not txtitem:
                txtitem = self.paramhist2[0]
                self.cbx2.SetValue(txtitem)
                
            if txtitem != self.paramhist2[0]:
                if txtitem in self.paramhist2:
                    self.paramhist2.remove(txtitem)
                self.paramhist2.insert(0, txtitem)
                if len(self.paramhist2) == 9:
                    del self.paramhist2[8]
                self.cbx2.Clear()
                for item in self.paramhist2:
                    self.cbx2.Append(item)
                self.cbx2.SetValue(txtitem)

        self.EndModal(wx.ID_OK)
    #-------------------------------------------------------------------------------------------

    def getValue(self):
        return self.paramhist
# - class ParamDialog(wx.Dialog):---------------------------------------------------------------
    

class BackupModeless(wx.Dialog):
    
    def __init__(self, parent, compact):        
        """  as """
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - DB backup')
        sizer = wx.BoxSizer(wx.VERTICAL)
        szh = wx.BoxSizer(wx.HORIZONTAL)
        if compact:
            st = wx.StaticText(self, -1, '... backing up currently used database to tar.gz archive\n\n... compacting / optimizing database')
        else:
            st = wx.StaticText(self, -1, '... backing up currently used database to tar.gz archive')
        szh.Add(st, 0, wx.ALL, GAP)
        sizer.Add(szh, 0, wx.GROW | wx.ALL, BORDER)
        self.SetSizer(sizer)
        self.Fit()
        self.Centre()
# - class ModelessDialog(wx.Dialog):---------------------------------------------------------------
    

class SkipOrOverwrite(wx.Dialog):
    ID_SKIP = wx.NewId()
    ID_SKIPALL = wx.NewId()
    ID_OVER = wx.NewId()
    ID_OVERALL = wx.NewId()
    
    def __init__(self, parent, filename):        
        """  as """
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - Copy / Convert warning')
        sizer = wx.BoxSizer(wx.VERTICAL)        

        st = wx.StaticText(self, -1, filename + '\n\nalready exists!')
        sizer.Add(st, 0, wx.ALL, BORDER)

        butskip = wx.Button(self, self.ID_SKIP, 'Skip')
        self.Bind(wx.EVT_BUTTON, self.onButton, id = self.ID_SKIP)
        butskipall = wx.Button(self, self.ID_SKIPALL, 'Skip all')
        self.Bind(wx.EVT_BUTTON, self.onButton, id = self.ID_SKIPALL)        
        butover = wx.Button(self, self.ID_OVER, 'Overwrite')
        self.Bind(wx.EVT_BUTTON, self.onButton, id = self.ID_OVER)        
        butoverall = wx.Button(self, self.ID_OVERALL, 'Overwrite all')
        self.Bind(wx.EVT_BUTTON, self.onButton, id = self.ID_OVERALL)        
               
        row2 = wx.BoxSizer(wx.HORIZONTAL)
        row2.AddStretchSpacer()
        row2.Add(butskip, 0, wx.GROW | wx.ALL, GAP)
        row2.Add(butskipall, 0, wx.GROW | wx.ALL, GAP)
        row2.Add(butover, 0, wx.GROW | wx.ALL, GAP)
        row2.Add(butoverall, 0, wx.GROW | wx.ALL, GAP)
        #row2.AddStretchSpacer()
    
        sl = wx.StaticLine(self, -1)
        sizer.Add(sl, 0, wx.GROW | LRT, BORDER)
        sizer.Add(row2, 0, wx.GROW | wx.ALL, BORDER)
        self.SetSizer(sizer)
        self.SetMinSize(wx.Size(350, -1))
        self.Fit()
        self.Centre()
    #-------------------------------------------------------------------------------------------

    def onButton(self, event):
        if event.GetId() == self.ID_SKIP:
            retval = 0
        elif event.GetId() == self.ID_SKIPALL:
            retval = 1
        elif event.GetId() == self.ID_OVER:
            retval = 2
        elif event.GetId() == self.ID_OVERALL:
            retval = 3
        self.EndModal(retval)
# - class ParamDialog(wx.Dialog):---------------------------------------------------------------
 
