#!/usr/bin/env python
#-*- coding: UTF-8 -*-
 
import os.path
import wx
from . import mumadir
from   .mumamisc import *


class PrefsDialog(wx.Dialog):
    """ all settings for this app """
    ID_BTN_COLOUR = wx.NewId()
    ID_CTRL_CSV = wx.NewId()
    ID_CTRL_COPY = wx.NewId()
    ID_RADIOBOX = wx.NewId()
    ID_RADIOBUTTON1 = wx.NewId()
    ID_RADIOBUTTON2 = wx.NewId()
    ID_RADIOORDER = wx.NewId()
    ID_RADIOUNITS = wx.NewId()
    ID_CB_GRID = wx.NewId()
    ID_CB_CONFIRM = wx.NewId()
    ID_CB_NEWTAB = wx.NewId()
    ID_CB_HIDETAB = wx.NewId()
    ID_CB_FILEDEL = wx.NewId()
    ID_CB_CASE = wx.NewId()
    ID_CB_AUTOEX = wx.NewId()
    ID_CB_INSTANCE = wx.NewId()
    ID_CB_NOTIFY = wx.NewId()
    ID_CB_MULTI = wx.NewId()
    ID_CB_ADDWARN = wx.NewId()
    ID_CB_UPDATE = wx.NewId()
    ID_CB_SPLASH = wx.NewId()
    ID_CB_PRIORITY = wx.NewId()
    ID_CB_HIDDEN = wx.NewId()
    ID_CB_ERRORLOG = wx.NewId()
    ID_CB_ACTIONLOG = wx.NewId()
    ID_CB_EXPERT = wx.NewId()
    ID_CB_NORM = wx.NewId()
    ID_CB_DQUOT = wx.NewId()
    ID_CB_MINI = wx.NewId()
    ID_CB_AUTODB = wx.NewId()
    ID_CB_EMPTYDT = wx.NewId()
    ID_CB_TOP25 = wx.NewId()
    ID_CB_AUTOM = wx.NewId()
    ID_CB_MISSING = wx.NewId()
    ID_BTN_BASE = wx.NewId()
    ID_BTN_DB = wx.NewId()
    ID_BTN_BKUP = wx.NewId()
    ID_BTN_MPLAYER = wx.NewId()
    ID_BTN_FFMPEG = wx.NewId()
    ID_BTN_COLOUR = wx.NewId()
    ID_BTN_COLOUR99 = wx.NewId()
    ID_BTN_COLOURMISS = wx.NewId()
    ID_BTN_ALTCOLOUR = wx.NewId()
    ID_BTN_EDITOR = wx.NewId()
    ID_TC_FTYPE = wx.NewId()
    ID_TXT_LINK = wx.NewId()
    EDITMSG = 'You can edit the music filetype. To accept, press RETURN'
    NOEDITMSG = 'You are currently not in edit mode'
    

    def __init__(self, parent, database, hlcolor, color99, altcolor, misscolor,inifilename):
        """ place preferences items on a dialog with 4 tabs """
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - Preferences')
        self.config = parent.config
        self.database = database
        self.onOpenDb = parent.onOpenDb
        self.hlcolor = hlcolor
        self.color99 = color99
        self.altcolor = altcolor
        self.misscolor = misscolor
        self.readonly_color = wx.SystemSettings.GetColour(READONLY_COLOR)
        self.Centre()
        btnadj = int(self.config['Misc']['norm'] == 'False')

        self.selectindex = len(self.config['Misc']['mfileexts']) - 1
        self.isadd = False
        self.playerchanged = False
        self.ffmpegchanged = False
        self.basechanged = False
        self.devicechanged = False
        self.audiochanged = False

        self.sizer = wx.BoxSizer(wx.VERTICAL)
        row1 = wx.BoxSizer(wx.HORIZONTAL)
        self.nb = wx.Notebook(self, -1)
        row1.Add(self.nb, 1, wx.GROW | wx.ALL, GAP)        
        self.initTab1()
        self.initTab2()
        self.initTab3()
        self.initTab4()
        self.initTab5(inifilename)
        
        self.butok1 = wx.Button(self, wx.ID_OK, '&OK')
        self.Bind(wx.EVT_BUTTON, self.onOk, id = wx.ID_OK)
        self.butcancel1 = wx.Button(self, wx.ID_CANCEL, '&Cancel')
        self.butok2 = wx.Button(self, wx.ID_OK, '&OK')
        self.Bind(wx.EVT_BUTTON, self.onOk, id = wx.ID_OK)
        self.butcancel2 = wx.Button(self, wx.ID_CANCEL, '&Cancel')
         
        row21 = wx.BoxSizer(wx.HORIZONTAL)
        row21.AddStretchSpacer()
        row21.Add(self.butok1, 0, wx.GROW | wx.ALL, GAP)
        row21.Add(self.butcancel1, 0, wx.GROW | wx.ALL, GAP)
        row22 = wx.BoxSizer(wx.HORIZONTAL)
        row22.Add(self.butok2, 1, wx.GROW | wx.ALL, GAP)
        row22.Add(self.butcancel2, 1, wx.GROW | wx.ALL, GAP)
        self.onCheckNorm()                    
        self.sizer.Add(row1, 1, wx.GROW | LRT, BORDER)
        self.sizer.Add(wx.BoxSizer(wx.HORIZONTAL), 0, wx.GROW | LRT, GAP)
        self.sizer.Add(row21, 0, wx.GROW | wx.LEFT | wx.RIGHT, GAP)
        self.sizer.Add(row22, 0, wx.GROW | wx.LEFT | wx.RIGHT , GAP)
        self.sizer.Add(wx.BoxSizer(wx.HORIZONTAL), 0, wx.GROW | wx.BOTTOM, GAP)
        self.SetSizer(self.sizer)
        self.Fit()
        self.Center()
    #-------------------------------------------------------------------------------------------

    def initTab1(self):
        page1 = wx.Panel(self.nb, -1)
        p1sizer = wx.BoxSizer(wx.VERTICAL)  
        lcsz = wx.FlexGridSizer(12, 3, 0, 0)
        lcsz.AddGrowableCol(1)
        st = wx.StaticText(page1, -1, 'with Grid:     ')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.cbg = wx.CheckBox(page1, self.ID_CB_GRID, ' (change applied after program restart)') 
        lcsz.Add(self.cbg, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckGrid, id = self.ID_CB_GRID)
        self.cbg.SetValue(self.config['ListCtrl']['grid'] == 'True')
        lcsz.AddStretchSpacer()                
        enu = wx.FontEnumerator()
        enu.EnumerateFacenames()
        fontlist = enu.GetFacenames()
        fontlist.sort()        
        st = wx.StaticText(page1, -1, 'Font family:    ')
        lcsz.Add(st, 0, wx.ALL, GAP)
        cbfont = wx.ComboBox(page1, -1, self.config['ListCtrl']['font'], 
                             choices = fontlist, style = wx.CB_DROPDOWN | wx.CB_READONLY)
        lcsz.Add(cbfont, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_COMBOBOX, self.onFontComboBox, cbfont)
        try:
            cbfont.SetSelection(fontlist.index(self.config['ListCtrl']['font']))
        except:
            pass
        lcsz.AddStretchSpacer()
        
        st = wx.StaticText(page1, -1, 'Font size:')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.scf = wx.SpinCtrl(page1, -1)
        self.scf.SetRange(6, 16)           
        self.scf.SetValue(int(self.config['ListCtrl']['fsize']))
        self.Bind(wx.EVT_SPINCTRL, self.onFontSize, self.scf)
        lcsz.Add(self.scf, 0, wx.GROW | wx.ALL, GAP)
        lcsz.AddStretchSpacer()

        st = wx.StaticText(page1, -1, 'Offer file del:')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.cbf = wx.CheckBox(page1, self.ID_CB_FILEDEL, ' (if checked - ask to delete file)') 
        lcsz.Add(self.cbf, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckFileDel, id = self.ID_CB_FILEDEL)
        self.cbf.SetValue(self.config['ListCtrl']['filedel'] == 'True')        
        lcsz.AddStretchSpacer()

        st = wx.StaticText(page1, -1, 'Confirmation:')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.cbc = wx.CheckBox(page1, self.ID_CB_CONFIRM, ' (if checked - show remove item dialog)') 
        lcsz.Add(self.cbc, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckConfirm, id = self.ID_CB_CONFIRM)
        self.cbc.SetValue(self.config['ListCtrl']['confirm'] == 'True')        
        lcsz.AddStretchSpacer()

        st = wx.StaticText(page1, -1, 'New query tab:')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.cbt = wx.CheckBox(page1, self.ID_CB_NEWTAB, ' (if checked - create new tab for queries)') 
        lcsz.Add(self.cbt, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckNewTab, id = self.ID_CB_NEWTAB)
        self.cbt.SetValue(self.config['ListCtrl']['newtab'] == 'True')        
        lcsz.AddStretchSpacer()
                
        st = wx.StaticText(page1, -1, 'Hide one tab:')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.cbh = wx.CheckBox(page1, self.ID_CB_HIDETAB, " (if checked - hide tab bar with < 2 tabs)") 
        lcsz.Add(self.cbh, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckHideTab, id = self.ID_CB_HIDETAB)
        self.cbh.SetValue(self.config['ListCtrl']['hidetab'] == 'True')        
        lcsz.AddStretchSpacer()
                
        st = wx.StaticText(page1, -1, 'Alternate colour:')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.tcaltcolor = wx.TextCtrl(page1, -1, ' %s ' % (str(self.altcolor)), style = wx.TE_READONLY)
        self.tcaltcolor.SetBackgroundColour(self.altcolor)
        lcsz.Add(self.tcaltcolor, 1, wx.ALL | wx.GROW, GAP)
        butcolour = wx.Button(page1, self.ID_BTN_ALTCOLOUR, ' New colour ')
        self.Bind(wx.EVT_BUTTON, self.onAltColour, id = self.ID_BTN_ALTCOLOUR)
        lcsz.Add(butcolour, 1, wx.ALL | wx.GROW, GAP)

        st = wx.StaticText(page1, -1, 'Highlight colour:')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.tccolor = wx.TextCtrl(page1, -1, ' %s ' % (str(self.hlcolor)), style = wx.TE_READONLY)
        self.tccolor.SetBackgroundColour(self.hlcolor)
        lcsz.Add(self.tccolor, 1, wx.ALL | wx.GROW, GAP)
        butcolour = wx.Button(page1, self.ID_BTN_COLOUR, ' New colour ')
        self.Bind(wx.EVT_BUTTON, self.onColour, id = self.ID_BTN_COLOUR)
        lcsz.Add(butcolour, 1, wx.ALL | wx.GROW, GAP)

        st = wx.StaticText(page1, -1, '99xxxx colour:')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.tccolor99 = wx.TextCtrl(page1, -1, ' %s ' % (str(self.color99)), style = wx.TE_READONLY)
        self.tccolor99.SetBackgroundColour(self.color99)
        lcsz.Add(self.tccolor99, 1, wx.ALL | wx.GROW, GAP)
        butcolour99 = wx.Button(page1, self.ID_BTN_COLOUR99, ' New colour ')
        self.Bind(wx.EVT_BUTTON, self.onColour99, id = self.ID_BTN_COLOUR99)
        lcsz.Add(butcolour99, 1, wx.ALL | wx.GROW, GAP)

        st = wx.StaticText(page1, -1, 'Missing colour:')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.tccolmiss = wx.TextCtrl(page1, -1, ' %s ' % (str(self.misscolor)), style = wx.TE_READONLY)
        self.tccolmiss.SetBackgroundColour(self.misscolor)
        lcsz.Add(self.tccolmiss, 1, wx.ALL | wx.GROW, GAP)
        butcolmiss = wx.Button(page1, self.ID_BTN_COLOURMISS, ' New colour ')
        self.Bind(wx.EVT_BUTTON, self.onMissColour, id = self.ID_BTN_COLOURMISS)
        lcsz.Add(butcolmiss, 1, wx.ALL | wx.GROW, GAP)
        
        st = wx.StaticText(page1, -1, 'Max. history len:')
        lcsz.Add(st, 0, wx.ALL, GAP)
        self.sclimit = wx.SpinCtrl(page1, -1)
        self.sclimit.SetRange(16, 1024)           
        self.sclimit.SetValue(int(self.config['Misc']['maxhistlen']))
        self.Bind(wx.EVT_SPINCTRL, self.onMaxHistlen, self.sclimit)
        lcsz.Add(self.sclimit, 0, wx.GROW | wx.ALL, GAP)
        lcsz.AddStretchSpacer()

        p1sizer.Add(lcsz, 0, wx.GROW | LRT, BORDER)        
        page1.SetSizer(p1sizer)
        self.nb.AddPage(page1, ' Gui ')
    #-------------------------------------------------------------------------------------------

    def initTab2(self):
        page2 = wx.Panel(self.nb, -1)
        p2sizer = wx.BoxSizer(wx.VERTICAL)  
        musz = wx.FlexGridSizer(13, 3, 0, 0)
        musz.AddGrowableCol(1)

        st = wx.StaticText(page2, -1, 'Dev label:')
        st.Enable(LINUX)
        musz.Add(st, 0, wx.ALL, GAP)
        self.ctrlmmp = wx.TextCtrl(page2, -1, self.config['Misc']['devlabel'])
        self.Bind(wx.EVT_TEXT, self.onDeviceLabel, self.ctrlmmp)
        musz.Add(self.ctrlmmp, 0, wx.ALL | wx.GROW, GAP)
        musz.AddStretchSpacer()
        self.ctrlmmp.Enable(LINUX)
            
        st = wx.StaticText(page2, -1, 'Auto(u)mount:')
        st.Enable(LINUX)
        musz.Add(st, 0, wx.ALL, GAP)
        self.cbam = wx.CheckBox(page2, self.ID_CB_AUTOM, ' (if checked - mount / umount music device)')
        musz.Add(self.cbam, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckAutom, id = self.ID_CB_AUTOM)
        self.cbam.SetValue(self.config['Misc']['automount'] == 'True')
        musz.AddStretchSpacer()
        self.cbam.Enable(LINUX)

        st = wx.StaticText(page2, -1, 'Music basedir:')
        musz.Add(st, 0, wx.ALL, GAP)
        self.ctrlmbd = wx.TextCtrl(page2, -1, self.config['Misc']['musicbase'], style = wx.TE_READONLY)
        self.ctrlmbd.SetBackgroundColour(self.readonly_color)
        self.Bind(wx.EVT_TEXT, self.onMusicBaseText, self.ctrlmbd)
        musz.Add(self.ctrlmbd, 0, wx.ALL | wx.GROW, GAP)
        self.btnbase = wx.Button(page2, self.ID_BTN_BASE, 'Browse')
        self.Bind(wx.EVT_BUTTON, self.onMusicBase, id = self.ID_BTN_BASE)
        musz.Add(self.btnbase, 1, wx.ALL | wx.GROW, GAP)

        st = wx.StaticText(page2, -1, 'Musicplayer:')
        musz.Add(st, 0, wx.ALL, GAP)
        self.cbplayer = wx.ComboBox(page2, -1, self.config['Misc']['player'][0], 
                                    choices = self.config['Misc']['player'],
                                    style = wx.TE_PROCESS_ENTER)
        musz.Add(self.cbplayer, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_TEXT, self.onPlayerText, self.cbplayer)
        self.btnmpl = wx.Button(page2, self.ID_BTN_MPLAYER, 'Browse') 
        self.Bind(wx.EVT_BUTTON, self.onMPlayer, id = self.ID_BTN_MPLAYER)
        musz.Add(self.btnmpl, 1, wx.ALL | wx.GROW, GAP)

        st = wx.StaticText(page2, -1, '')
        musz.Add(st, 0, wx.GROW | wx.ALL, GAP)
        msgtext = wx.StaticText(page2, -1, 'Example: [path]name_of_musicplayer [options]')
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        msgtext.SetFont(font)
        musz.Add(msgtext, 0, wx.GROW | wx.ALL, GAP)
        musz.AddStretchSpacer()
 
        st = wx.StaticText(page2, -1, 'Converter:')
        musz.Add(st, 0, wx.ALL, GAP)
        self.ctrlffd = wx.TextCtrl(page2, -1, self.config['Misc']['ffmpeg'], style = wx.TE_READONLY)
        self.ctrlffd.SetBackgroundColour(self.readonly_color)
        self.Bind(wx.EVT_TEXT, self.onFfmpegText, self.ctrlffd)
        musz.Add(self.ctrlffd, 0, wx.ALL | wx.GROW, GAP)
        self.btnffd = wx.Button(page2, self.ID_BTN_FFMPEG, 'Browse') 
        self.Bind(wx.EVT_BUTTON, self.onFfmpegDir, id = self.ID_BTN_FFMPEG)
        musz.Add(self.btnffd, 1, wx.ALL | wx.GROW, GAP)       
        musz.AddStretchSpacer()
        self.msgtext = wx.StaticText(page2, -1, "Example: [path]avconv or [path]ffmpeg (binary / exe)")
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        self.msgtext.SetFont(font)
        musz.Add(self.msgtext, 0, wx.GROW | wx.ALL, GAP)
        musz.AddStretchSpacer()
 
        st = wx.StaticText(page2, -1, 'Audio editor:')
        musz.Add(st, 0, wx.ALL, GAP)
        self.ctrlaudio = wx.TextCtrl(page2, -1, self.config['Misc']['editor'], style = wx.TE_READONLY)
        self.ctrlaudio.SetBackgroundColour(self.readonly_color)
        self.Bind(wx.EVT_TEXT, self.onAudioEditorText, self.ctrlaudio)
        musz.Add(self.ctrlaudio, 0, wx.ALL | wx.GROW, GAP)
        self.btnaudio = wx.Button(page2, self.ID_BTN_EDITOR, 'Browse')
        self.Bind(wx.EVT_BUTTON, self.onAudioEditorDir, id = self.ID_BTN_EDITOR)
        musz.Add(self.btnaudio, 1, wx.ALL | wx.GROW, GAP)
        musz.AddStretchSpacer()
        self.msgtext = wx.StaticText(page2, -1, "Example: [path]name_of_audioeditor")
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        self.msgtext.SetFont(font)
        musz.Add(self.msgtext, 0, wx.GROW | wx.ALL, GAP)
        musz.AddStretchSpacer()
        
        st = wx.StaticText(page2, -1, 'Title csv path:')
        musz.Add(st, 0, wx.ALL, GAP)
        self.ctrltip = wx.TextCtrl(page2, -1, self.config['Misc']['titlecsv'], style = wx.TE_READONLY)
        self.ctrltip.SetBackgroundColour(self.readonly_color)
        musz.Add(self.ctrltip, 0, wx.ALL | wx.GROW, GAP)
        musz.AddStretchSpacer()

        st = wx.StaticText(page2, -1, 'Place csv path:')
        musz.Add(st, 0, wx.ALL, GAP)
        self.ctrlpip = wx.TextCtrl(page2, -1, self.config['Misc']['placecsv'], style = wx.TE_READONLY)
        self.ctrlpip.SetBackgroundColour(self.readonly_color)
        musz.Add(self.ctrlpip, 0, wx.ALL | wx.GROW, GAP)
        musz.AddStretchSpacer()

        st = wx.StaticText(page2, -1, 'Export path:')
        musz.Add(st, 0, wx.ALL, GAP)
        self.ctrlcsv = wx.TextCtrl(page2, self.ID_CTRL_CSV, self.config['Misc']['csvname'],
                                   style = wx.TE_READONLY)
        self.ctrlcsv.SetBackgroundColour(self.readonly_color)        
        musz.Add(self.ctrlcsv, 0, wx.ALL | wx.GROW, GAP)
        musz.AddStretchSpacer()

        st = wx.StaticText(page2, -1, 'Copy files path:')
        musz.Add(st, 0, wx.ALL, GAP)
        self.ctrlcopy = wx.TextCtrl(page2, self.ID_CTRL_COPY, self.config['Misc']['copydir'],
                                    style = wx.TE_READONLY)
        self.ctrlcopy.SetBackgroundColour(self.readonly_color)        
        musz.Add(self.ctrlcopy, 0, wx.ALL | wx.GROW, GAP)
        musz.AddStretchSpacer()
    
        p2sizer.Add(musz, 0, wx.GROW | LRT, BORDER)        
        page2.SetSizer(p2sizer)
        self.nb.AddPage(page2, ' Music ')
    #-------------------------------------------------------------------------------------------

    def initTab3(self):
        page3 = wx.Panel(self.nb, -1)
        p3sizer = wx.BoxSizer(wx.VERTICAL)  
        ftsz = wx.FlexGridSizer(4, 1, 0, 0)
        ftsz.AddGrowableCol(0)
        ftsz.AddGrowableRow(1)

        self.msgtext = wx.StaticText(page3, -1, 'Hint: filetypes are always listed in lowercase. Searching is done in any case.')
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        self.msgtext.SetFont(font)
        ftsz.Add(self.msgtext, 0, wx.GROW | wx.ALL, GAP)

        self.lbft = wx.ListBox(page3, -1, style = wx.LB_SINGLE | wx.LB_HSCROLL)
        ftsz.Add(self.lbft, 0, wx.EXPAND | wx.ALL, GAP)
        self.Bind(wx.EVT_LISTBOX, self.onSelected)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onEdit)
        self.updateListBox()

        self.msgtext = wx.StaticText(page3, -1, self.NOEDITMSG)
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        self.msgtext.SetFont(font)
        ftsz.Add(self.msgtext, 0, wx.GROW | wx.ALL, GAP)
        self.tcft = wx.TextCtrl(page3, self.ID_TC_FTYPE, style = wx.TE_PROCESS_ENTER | wx.TE_READONLY)
        self.tcft.SetBackgroundColour(self.readonly_color)
        ftsz.Add(self.tcft, 0, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_TEXT_ENTER, self.onTextEnter, id = self.ID_TC_FTYPE)
        p3sizer.Add(ftsz, 1, wx.GROW | LRT, BORDER)    

        butadd = wx.Button(page3, wx.ID_ADD)
        butedit = wx.Button(page3, wx.ID_EDIT)
        butrem = wx.Button(page3, wx.ID_REMOVE)
        self.Bind(wx.EVT_BUTTON, self.onButtonAdd, id = wx.ID_ADD)
        self.Bind(wx.EVT_BUTTON, self.onEdit, id = wx.ID_EDIT)
        self.Bind(wx.EVT_BUTTON, self.onButtonRem, id = wx.ID_REMOVE)

        butsz = wx.BoxSizer(wx.HORIZONTAL)
        butsz.Add(butadd, 1, wx.GROW | wx.ALL, GAP)
        butsz.Add(butedit, 1, wx.GROW | wx.ALL, GAP)
        butsz.Add(butrem, 1, wx.GROW | wx.ALL, GAP)
        p3sizer.Add(butsz, 0, wx.GROW | wx.LEFT | wx.RIGHT, BORDER)
           
        page3.SetSizer(p3sizer)
        self.nb.AddPage(page3, ' Filetypes ')
    #-------------------------------------------------------------------------------------------

    def initTab4(self):
        page4 = wx.Panel(self.nb, -1)
        p4sizer = wx.BoxSizer(wx.VERTICAL)  
        dbsz = wx.FlexGridSizer(10, 3, 0, 0)
        dbsz.AddGrowableCol(1)
        
        dbpath = self.config['Database']['pathname']
        st = wx.StaticText(page4, -1, 'DB path:')
        dbsz.Add(st, 0, wx.ALL, GAP)
        self.ctrldb = wx.TextCtrl(page4, -1, dbpath, style = wx.TE_READONLY)
        self.ctrldb.SetBackgroundColour(self.readonly_color)
        dbsz.Add(self.ctrldb, 0, wx.ALL | wx.GROW, GAP)
        self.btnbdb = wx.Button(page4, self.ID_BTN_DB, 'Browse')
        self.Bind(wx.EVT_BUTTON, self.onOpenDbBtn, id = self.ID_BTN_DB)
        dbsz.Add(self.btnbdb, 1, wx.ALL | wx.GROW, GAP)
            
        st = wx.StaticText(page4, -1, 'DB data size:')
        dbsz.Add(st, 0, wx.ALL, GAP)
        if self.database != None:
            self.stsz = wx.StaticText(page4, -1, format3P(os.path.getsize(dbpath)) +
                                      ' Bytes for ' + format3P(self.database.getRecordCount(self.database.TAB_TITLE)) +
                                      ' Records')
        else:
            self.stsz = wx.StaticText(page4, -1, ' ')
        dbsz.Add(self.stsz, 0, wx.ALL, GAP)
        dbsz.AddStretchSpacer()

        st = wx.StaticText(page4, -1, 'DB last update:')
        dbsz.Add(st, 0, wx.ALL, GAP)
        if self.database != None:
            self.stsz = wx.StaticText(page4, -1, self.database.getLastUpdate())
        else:
            self.stsz = wx.StaticText(page4, -1, ' ')
        dbsz.Add(self.stsz, 0, wx.ALL, GAP)
        dbsz.AddStretchSpacer()

        st = wx.StaticText(page4, -1, 'Backup path:')
        dbsz.Add(st, 0, wx.ALL, GAP)
        self.ctrlbup = wx.TextCtrl(page4, -1, self.config['Database']['bkuppath'], style = wx.TE_READONLY) 
        self.ctrlbup.SetBackgroundColour(self.readonly_color)
        dbsz.Add(self.ctrlbup, 0, wx.ALL | wx.GROW, GAP)
        self.btnbup = wx.Button(page4, self.ID_BTN_BKUP, 'Browse')
        self.Bind(wx.EVT_BUTTON, self.onBackupDir, id = self.ID_BTN_BKUP)
        dbsz.Add(self.btnbup, 1, wx.ALL | wx.GROW, GAP)

        st = wx.StaticText(page4, -1, 'Max. backups:')
        dbsz.Add(st, 0, wx.ALL, GAP)
        self.bklimit = wx.SpinCtrl(page4, -1)
        self.bklimit.SetRange(0, 1024)           
        self.bklimit.SetValue(int(self.config['Misc']['bkupcount']))
        self.Bind(wx.EVT_SPINCTRL, self.onMaxBkupCount, self.bklimit)
        dbsz.Add(self.bklimit, 0, wx.GROW | wx.ALL, GAP)
        dbsz.AddStretchSpacer()

        st = wx.StaticText(page4, -1, 'Multi backups:')
        dbsz.Add(st, 0, wx.ALL, GAP)
        self.cbb = wx.CheckBox(page4, self.ID_CB_MULTI, ' (if checked - enable multiple per day)')
        dbsz.Add(self.cbb, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckMultiBkup, id = self.ID_CB_MULTI)
        self.cbb.SetValue(self.config['Misc']['multibkup'] == 'True')
        dbsz.AddStretchSpacer()
        
        st = wx.StaticText(page4, -1, 'Quick query limit:')
        dbsz.Add(st, 0, wx.ALL, GAP)
        self.qqlimit = wx.SpinCtrl(page4, -1)
        self.qqlimit.SetRange(16, 2048)           
        self.qqlimit.SetValue(int(self.config['Database']['qqlimit']))
        self.Bind(wx.EVT_SPINCTRL, self.onQqLimit, self.qqlimit)
        dbsz.Add(self.qqlimit, 0, wx.GROW | wx.ALL, GAP)
        dbsz.AddStretchSpacer()
                
        st = wx.StaticText(page4, -1, 'Add warning:')
        dbsz.Add(st, 0, wx.ALL, GAP)
        self.cbw = wx.CheckBox(page4, self.ID_CB_ADDWARN, " (if checked - music file not found warning)")
        dbsz.Add(self.cbw, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckWarning, id = self.ID_CB_ADDWARN)
        self.cbw.SetValue(self.config['Database']['addwarn'] == 'True')
        dbsz.AddStretchSpacer()

        st = wx.StaticText(page4, -1, 'Empty datetime:')
        dbsz.Add(st, 0, wx.ALL, GAP)
        self.cbdt = wx.CheckBox(page4, self.ID_CB_EMPTYDT, " (if checked - empty fields are allowed)")
        dbsz.Add(self.cbdt, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckEmptyDT, id = self.ID_CB_EMPTYDT)
        self.cbdt.SetValue(self.config['Database']['emptydt'] == 'True')
        dbsz.AddStretchSpacer()
        
        st = wx.StaticText(page4, -1, 'Database URL:')
        dbsz.Add(st, 0, wx.ALL, GAP)
        self.ctrllink = wx.TextCtrl(page4, self.ID_TXT_LINK, self.config['Database']['link'])
        dbsz.Add(self.ctrllink, 0, wx.ALL | wx.GROW, GAP)
        #self.Bind(wx.EVT_TEXT, self.onLinkEntry, id = self.ID_TXT_LINK)
        dbsz.AddStretchSpacer()
        
        p4sizer.Add(dbsz, 0, wx.GROW | LRT, BORDER)        
        page4.SetSizer(p4sizer)
        self.nb.AddPage(page4, ' Database ')
    #-------------------------------------------------------------------------------------------

    def initTab5(self, inifilename):
        page5 = wx.Panel(self.nb, -1)
        p5sizer = wx.BoxSizer(wx.VERTICAL)  
        miscsz = wx.FlexGridSizer(12, 2, 0, 0)
        miscsz.AddGrowableCol(1)
        
        st = wx.StaticText(page5, -1, 'Ini path:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.ctrlini = wx.TextCtrl(page5, -1, inifilename, style = wx.TE_READONLY)
        self.ctrlini.SetBackgroundColour(self.readonly_color)
        miscsz.Add(self.ctrlini, 0, wx.ALL | wx.GROW, GAP)

        st = wx.StaticText(page5, -1, 'Multiple Instance:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cbi = wx.CheckBox(page5, self.ID_CB_INSTANCE, ' (change applied after program restart)')
        miscsz.Add(self.cbi, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckInstance, id = self.ID_CB_INSTANCE)
        self.cbi.SetValue(self.config['Misc']['instance'] == 'True')       

        st = wx.StaticText(page5, -1, 'Notification:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cbn = wx.CheckBox(page5, self.ID_CB_NOTIFY, ' (if checked - enable systray notification)')
        miscsz.Add(self.cbn, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckNotify, id = self.ID_CB_NOTIFY)
        self.cbn.SetValue(self.config['Misc']['notify'] == 'True')       

        st = wx.StaticText(page5, -1, 'Splash screen:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cbs = wx.CheckBox(page5, self.ID_CB_SPLASH, ' (if checked - enable splash screen)')
        miscsz.Add(self.cbs, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckSplash, id = self.ID_CB_SPLASH)
        self.cbs.SetValue(self.config['Misc']['splash'] == 'True')       

        st = wx.StaticText(page5, -1, 'Update check:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cbu = wx.CheckBox(page5, self.ID_CB_UPDATE, ' (if checked - search for updated program and DB)')
        miscsz.Add(self.cbu, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckUpdate, id = self.ID_CB_UPDATE)
        self.cbu.SetValue(self.config['Misc']['update'] == 'True')       

        st = wx.StaticText(page5, -1, 'Action log:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cba = wx.CheckBox(page5, self.ID_CB_ACTIONLOG, ' (if checked - write Log messages)')
        miscsz.Add(self.cba, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckActionlog, id = self.ID_CB_ACTIONLOG)
        self.cba.SetValue(self.config['Misc']['actionlog'] == 'True')       

        st = wx.StaticText(page5, -1, 'Hidden dirs:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cbd = wx.CheckBox(page5, self.ID_CB_HIDDEN, ' (if checked - show hidden dirs / files)')
        miscsz.Add(self.cbd, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckHidden, id = self.ID_CB_HIDDEN)
        self.cbd.SetValue(self.config['Misc']['hiddendirs'] == 'True')       

        st = wx.StaticText(page5, -1, 'Expert mode:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cbx = wx.CheckBox(page5, self.ID_CB_EXPERT, ' (if checked - enable modify database - USE WITH CARE)')
        miscsz.Add(self.cbx, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckExpert, id = self.ID_CB_EXPERT)
        self.cbx.SetValue(self.config['Misc']['expert'] == 'True')       

        st = wx.StaticText(page5, -1, 'Button align:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cby = wx.CheckBox(page5, self.ID_CB_NORM, " (if checked - 'norm' style - right aligned)")
        miscsz.Add(self.cby, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckNorm, id = self.ID_CB_NORM)
        self.cby.SetValue(self.config['Misc']['norm'] == 'True')       

        st = wx.StaticText(page5, -1, 'Proc args:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cbp = wx.CheckBox(page5, self.ID_CB_DQUOT, " (if checked - process arguments with quotation marks)")
        miscsz.Add(self.cbp, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckDquot, id = self.ID_CB_DQUOT)
        self.cbp.SetValue(self.config['Misc']['dquotation'] == 'True')       

        st = wx.StaticText(page5, -1, 'My Top 25:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cbt25 = wx.CheckBox(page5, self.ID_CB_TOP25, " (if checked - maintain My Top 25 playlist)")
        miscsz.Add(self.cbt25, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckTop25, id = self.ID_CB_TOP25)
        self.cbt25.SetValue(self.config['Misc']['top25'] == 'True')       

        st = wx.StaticText(page5, -1, 'Missing titles:')
        miscsz.Add(st, 0, wx.ALL, GAP)
        self.cbmt = wx.CheckBox(page5, self.ID_CB_MISSING, " (if checked - scan music device for missing titles)")
        miscsz.Add(self.cbmt, 0, wx.ALL, GAP)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckMissing, id = self.ID_CB_MISSING)
        self.cbmt.SetValue(self.config['Misc']['missing'] == 'True')       

        p5sizer.Add(miscsz, 0, wx.GROW | LRT, BORDER)        
        page5.SetSizer(p5sizer)
        self.nb.AddPage(page5, ' Misc ')
    #-------------------------------------------------------------------------------------------

    def onOpenDbBtn(self, event):
        self.onOpenDb()
        dbpath = self.config['Database']['pathname']
        self.ctrldb.ChangeValue(dbpath)
        self.stsz.SetLabel(format3P(os.path.getsize(dbpath)) + ' Bytes')
    #-------------------------------------------------------------------------------------------

    def onButtonAdd(self, event):
        self.tcft.SetEditable(False)
        self.msgtext.SetLabel(self.NOEDITMSG)
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        self.msgtext.SetFont(font)
        self.tcft.Clear()
        self.isadd = True
        self.onEdit()
    #-------------------------------------------------------------------------------------------
    
   # def onLinkEntry(self, event):
    #    print self.ctrllink.GetValue()
     #   pass
    #-------------------------------------------------------------------------------------------    
    
    def onEdit(self, event = None):
        self.tcft.Clear()
        if not self.isadd:
            self.tcft.WriteText(self.config['Misc']['mfileexts'][self.selectindex])
        self.tcft.SetEditable(True)
        self.tcft.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_WINDOW))
        self.msgtext.SetLabel(self.EDITMSG)
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        self.msgtext.SetFont(font)        
        self.tcft.SetFocusFromKbd()
        self.tcft.SetInsertionPointEnd()
    #-------------------------------------------------------------------------------------------

    def onTextEnter(self, event):
        newtype = self.tcft.GetValue().strip().lower()
        if len(newtype):
            if not self.isadd:
                self.config['Misc']['mfileexts'][self.selectindex] = newtype
            elif newtype not in self.config['Misc']['mfileexts']:
                self.config['Misc']['mfileexts'].append(newtype)
        self.tcft.SetEditable(False)
        self.tcft.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BACKGROUND))
        self.tcft.Clear()
        self.msgtext.SetLabel(self.NOEDITMSG)
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        self.msgtext.SetFont(font)        
        self.updateListBox()
        self.isadd = False
    #-------------------------------------------------------------------------------------------

    def onButtonRem(self, event):
        self.tcft.SetEditable(False)
        self.tcft.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BACKGROUND))
        self.msgtext.SetLabel(self.NOEDITMSG)
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        self.msgtext.SetFont(font)        
        if self.selectindex != - 1:
            del self.config['Misc']['mfileexts'][self.selectindex]
            self.tcft.Clear()            
            self.selectindex = len(self.config['Misc']['mfileexts']) - 1
            self.updateListBox()
    #-------------------------------------------------------------------------------------------

    def onSelected(self, event):
        selectindex = event.GetSelection()
        if selectindex >= 0:
            self.selectindex = selectindex
            self.tcft.Clear()
            self.tcft.SetEditable(False)
            self.tcft.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_BACKGROUND))
            self.msgtext.SetLabel(self.NOEDITMSG)
            font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
            self.msgtext.SetFont(font)
    #-------------------------------------------------------------------------------------------
    
    def updateListBox(self):
        self.lbft.Clear()
        self.config['Misc']['mfileexts'].sort()
        self.lbft.Set(self.config['Misc']['mfileexts'])
        self.lbft.SetFocus()
        try:
            self.lbft.Select(self.selectindex)
        except:
            pass
    #-------------------------------------------------------------------------------------------

    def onMPlayer(self, event):
        """  """
        dlg = mumadir.DirDialog(self, TITLE + ' - select music player', self.config, 
                                '', mode = 'openf', filters = WILDEXEC)
        if dlg.ShowModal() == wx.ID_OPEN:
            self.playerchanged = False
            self.cbplayer.SetValue(os.path.normpath(dlg.GetPath()))
    #-------------------------------------------------------------------------------------------   

    def onFfmpegDir(self, event):
        dlg = mumadir.DirDialog(self, TITLE + ' - select converter', self.config,
                                '', mode = 'openf', filters = WILDEXEC)
        if dlg.ShowModal() == wx.ID_OPEN:
            self.ffmpegchanged = False
            path = os.path.normpath(dlg.GetFilePath())
            self.config['Misc']['ffmpeg'] = path
            self.ctrlffd.SetValue(path)
        dlg.Destroy()
    #-------------------------------------------------------------------------------------------

    def onBackupDir(self, event):
        dlg = mumadir.DirDialog(self, TITLE + ' - select backup basepath', self.config, 
                                self.config['Database']['bkuppath'], mode = 'opend')
        if dlg.ShowModal() == wx.ID_OPEN:
            self.basechanged = False
            path = os.path.normpath(dlg.GetPath())
            self.config['Database']['bkuppath'] = path
            self.ctrlbup.SetValue(path)
        dlg.Destroy()
    #-------------------------------------------------------------------------------------------

    def onMusicBase(self, event):
        dlg = mumadir.DirDialog(self, TITLE + ' - select music basepath', self.config, 
                                self.config['Misc']['musicbase'], mode = 'opend')
        if dlg.ShowModal() == wx.ID_OPEN:
            self.basechanged = False
            path = os.path.normpath(dlg.GetPath())
            self.config['Misc']['musicbase'] = path
            self.ctrlmbd.SetValue(path)
        dlg.Destroy()
    #-------------------------------------------------------------------------------------------

    def onMountpoint(self, event):
        self.mpointchanged = True
    #-------------------------------------------------------------------------------------------

    def onMusicBaseText(self, event):
        self.basechanged = True
    #-------------------------------------------------------------------------------------------
    
    def onDeviceLabel(self, event):
        self.devicechanged = True
    #-------------------------------------------------------------------------------------------

    def onFfmpegText(self, event):
        self.ffmpegchanged = True
    #-------------------------------------------------------------------------------------------

    def onAudioEditorDir(self, event):
        dlg = mumadir.DirDialog(self, TITLE + ' - select audio editor', self.config,
                                '', mode = 'openf', filters = WILDEXEC)
        if dlg.ShowModal() == wx.ID_OPEN:
            self.audiochanged = False
            path = os.path.normpath(dlg.GetFilePath())
            self.config['Misc']['editor'] = path
            self.ctrlaudio.SetValue(path)
        dlg.Destroy()
    #-------------------------------------------------------------------------------------------
        
    def onAudioEditorText(self, event):        
        self.audiochanged = True
    #-------------------------------------------------------------------------------------------
    
    def onFontComboBox(self, event):
        self.config['ListCtrl']['font'] = event.GetString()
    #-------------------------------------------------------------------------------------------

    def onMaxHistlen(self, event):
        self.config['Misc']['maxhistlen'] = str(event.GetInt())
    #-------------------------------------------------------------------------------------------

    def onMaxBkupCount(self, event):
        self.config['Misc']['bkupcount'] = str(event.GetInt())
    #-------------------------------------------------------------------------------------------

    def onQqLimit(self, event):
        self.config['Database']['qqlimit'] = str(event.GetInt())
    #-------------------------------------------------------------------------------------------

    def onFontSize(self, event):
        self.config['ListCtrl']['fsize'] = str(event.GetInt())
    #-------------------------------------------------------------------------------------------

    def onPlayerText(self, event = None):        
        self.playerchanged = True
    #-------------------------------------------------------------------------------------------

    def onFileextsComboBox(self, event = None):
        comboBoxHistory(self.cbexts, self.config, 'Misc', 'mfileexts')
    #-------------------------------------------------------------------------------------------

    def onColour(self, event):
        data = wx.ColourData()
        data.SetColour(self.hlcolor)
        dlg = wx.ColourDialog(self, data)
        if dlg.ShowModal() == wx.ID_OK:
            data = dlg.GetColourData()
            self.hlcolor = data.GetColour().Get()
            self.tccolor.SetValue(' %s ' % (str(self.hlcolor)))
            self.tccolor.SetBackgroundColour(self.hlcolor)
    #-------------------------------------------------------------------------------------------

    def onAltColour(self, event):
        data = wx.ColourData()
        data.SetColour(self.altcolor)
        dlg = wx.ColourDialog(self, data)
        if dlg.ShowModal() == wx.ID_OK:
            data = dlg.GetColourData()
            self.altcolor = data.GetColour().Get()
            self.tcaltcolor.SetValue(' %s ' % (str(self.altcolor)))
            self.tcaltcolor.SetBackgroundColour(self.altcolor)
    #-------------------------------------------------------------------------------------------

    def onColour99(self, event):
        data = wx.ColourData()
        data.SetColour(self.color99)
        dlg = wx.ColourDialog(self, data)
        if dlg.ShowModal() == wx.ID_OK:
            data = dlg.GetColourData()
            self.color99 = data.GetColour().Get()
            self.tccolor99.SetValue(' %s ' % (str(self.color99)))
            self.tccolor99.SetBackgroundColour(self.color99)
    #-------------------------------------------------------------------------------------------

    def onMissColour(self, event):
        data = wx.ColourData()
        data.SetColour(self.misscolor)
        dlg = wx.ColourDialog(self, data)
        if dlg.ShowModal() == wx.ID_OK:
            data = dlg.GetColourData()
            self.misscolor = data.GetColour().Get()
            self.tccolmiss.SetValue(' %s ' % (str(self.misscolor)))
            self.tccolmiss.SetBackgroundColour(self.misscolor)
    #-------------------------------------------------------------------------------------------

    def onCheckNorm(self, event = None):
        self.config['Misc']['norm'] = str(self.cby.GetValue())
        btnadj = int(self.config['Misc']['norm'] == 'False')
        if btnadj:
            self.butok1.Hide()
            self.butcancel1.Hide()
            self.butok2.Show()
            self.butcancel2.Show()
        else:
            self.butok1.Show()
            self.butcancel1.Show()
            self.butok2.Hide()
            self.butcancel2.Hide()
        self.sizer.Layout()
        self.Refresh()
    #-------------------------------------------------------------------------------------------

    def onCheckAutom(self, event):
        self.config['Misc']['automount'] = str(self.cbam.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckHidden(self, event):
        self.config['Misc']['hiddendirs'] = str(self.cbd.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckExpert(self, event):
        self.config['Misc']['expert'] = str(self.cbx.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckHideTab(self, event):
        self.config['ListCtrl']['hidetab'] = str(self.cbh.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckNewTab(self, event):
        self.config['ListCtrl']['newtab'] = str(self.cbt.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckConfirm(self, event):
        self.config['ListCtrl']['confirm'] = str(self.cbc.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckFileDel(self, event):
        self.config['ListCtrl']['filedel'] = str(self.cbf.GetValue())
        if self.config['ListCtrl']['filedel'] == 'True':
            self.config['ListCtrl']['confirm'] = 'True'
            self.cbc.SetValue(True)   
    #-------------------------------------------------------------------------------------------

    def onCheckMissing(self, event):
        self.config['Misc']['missing'] = str(self.cbmt.GetValue())
    #-------------------------------------------------------------------------------------------

    def onOk(self, event):
        comboBoxHistory(self.cbplayer, self.config, 'Misc', 'player')
        splitlist = self.config['Misc']['player'][0].split(' -')
        player = splitlist[0].strip()
        if not LINUX and not player.lower().endswith('.exe'):
            player = player + '.exe'                    
        playerfound, playerpath = searchFile(player)
        
        if self.playerchanged and not playerfound:
            dlg = wx.MessageDialog(self, 'Music player not found or is not accessible!\nProceed anyway?', TITLE + ' - Preferences', wx.YES_NO | wx.NO_DEFAULT | wx.ICON_WARNING)
            if dlg.ShowModal() != wx.ID_YES:
                return            
        
        musicbase = self.ctrlmbd.GetValue()
        if self.basechanged and not os.path.exists(musicbase):
            dlg = wx.MessageDialog(self, 'Music basedir does not exist or is not accessible!\nProceed anyway?', TITLE + ' - Preferences', wx.YES_NO | wx.NO_DEFAULT | wx.ICON_WARNING)
            if dlg.ShowModal() != wx.ID_YES:
                return
        self.config['Misc']['musicbase'] = musicbase
        
        audio = self.ctrlaudio.GetValue()
        if not LINUX and not audio.lower().endswith('.exe'):
            audio = audio + '.exe'
        audiofound, audiopath = searchFile(audio)
        if self.audiochanged and not audiofound:
            dlg = wx.MessageDialog(self, 'Audio editor not found or is not accessible!\nProceed anyway?', TITLE + ' - Preferences', wx.YES_NO | wx.NO_DEFAULT | wx.ICON_WARNING)
            if dlg.ShowModal() != wx.ID_YES:
                return            
        
        if self.devicechanged:
            self.config['Misc']['devlabel'] = self.ctrlmmp.GetValue()
        
        ffmpeg = self.ctrlffd.GetValue()
        if not LINUX and not ffmpeg.lower().endswith('.exe'):
            ffmpeg = ffmpeg + '.exe'
        ffmpegfound, ffmpegpath = searchFile(ffmpeg)
        if self.ffmpegchanged and not ffmpegfound:
            dlg = wx.MessageDialog(self, 'Converter ffmpeg not found or is not accessible!\nProceed anyway?', TITLE + ' - Preferences', wx.YES_NO | wx.NO_DEFAULT | wx.ICON_WARNING)
            if dlg.ShowModal() != wx.ID_YES:
                return   
        self.config['Misc']['ffmpeg'] = self.ctrlffd.GetValue()
        self.config['Misc']['mountpoint'] = self.ctrlmmp.GetValue()
        self.config['Database']['link'] = self.ctrllink.GetValue().strip()
        event.Skip()
    #-------------------------------------------------------------------------------------------
    
    def onCheckEmptyDT(self, event):
        self.config['Database']['emptydt'] = str(self.cbdt.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckWarning(self, event):
        self.config['Database']['addwarn'] = str(self.cbw.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckMini(self, event):
        self.config['Execution']['startmin'] = str(self.cbm.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckMultiBkup(self, event):
        self.config['Misc']['multibkup'] = str(self.cbb.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckGrid(self, event):
        """  """
        self.config['ListCtrl']['grid'] = str(self.cbg.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckSplash(self, event):
        self.config['Misc']['splash'] = str(self.cbs.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckInstance(self, event):
        self.config['Misc']['instance'] = str(self.cbi.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckNotify(self, event):
        self.config['Misc']['notify'] = str(self.cbn.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckUpdate(self, event):
        self.config['Misc']['update'] = str(self.cbu.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckActionlog(self, event):
        """  """
        self.config['Misc']['actionlog'] = str(self.cba.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckDquot(self, event):
        """  """
        self.config['Misc']['dquotation'] = str(self.cbp.GetValue())
    #-------------------------------------------------------------------------------------------

    def onCheckTop25(self, event):
        self.config['Misc']['top25'] = str(self.cbt25.GetValue())
    #-------------------------------------------------------------------------------------------

    def getNewConfig(self):
        """  """
        self.config['Misc']['hlcolor'] = self.hlcolor
        self.config['Misc']['99color'] = self.color99
        self.config['Misc']['altcolor'] = self.altcolor
        self.config['Misc']['misscolor'] = self.misscolor
        return self.config
# - class PrefDialog(wx.Dialog):----------------------------------------------------------------

